/*
 * pcidump.c
 *
 * original code: SASANO Takayoshi
 * --- public domain, no warranty.
 */
#include <basic.h>
#include <bstdio.h>
#include <errcode.h>
#include <driver/pcat/pci.h>

/* $B%l%8%9%?$NFbMFI=<((B */
LOCAL	VOID	regdisp(W caddr)
{
	W	reg;

	for (reg = 0; reg < 0x100; reg += 4) {
		if (!(reg & 0x1f)) printf("%02x: ", reg);
		printf("%08x", inPciConfW(caddr, reg));
		printf("%c", ((reg & 0x1f) == 0x1c) ? '\n' : ' ');
	}

	return;
}

/* $B%a%$%s!&(BPCI$B%G%P%$%9$N8!:w(B */
EXPORT	W	main(W argc, TC *argv[])
{
	W	i, caddr;

	for (i = 0; (caddr = searchPciDev(SEARCH_ALL, i)) >= 0; i++) {
		printf("[%4x]\n", caddr);
		regdisp(caddr);
	}

	return ER_OK;
}
